Page MenuHomePhabricator

Identify target wikis for mobile editing improvements
Open, NormalPublic

Description

What is the problem?

The Editing team wants to improve the mobile editing experience. Some aspects of the mobile editing experience vary significantly by language/script. We would like to work with a small number of target wikis, so that we can make language-specific improvements. This project could significantly ease their everyday editing work.

What does success of this task look like? How do we know when we are done?

One to four Wikipedias where mobile editing is already substantial will volunteer to be the first in line for the planned improvements.

Is there any goal, program, project, team related with this request? Please provide links and use the corresponding Phabricator tags when available.

This is part of Editing's annual plan program.

What is your expected timeline from start to end? Is there a hard deadline?

About three weeks, in November 2018.

Please list the subtasks that you would need a Specialist to perform.

  • Evaluate communities in the target list.
  • Talk to communities about this opportunity.

Event Timeline

Deskana created this task.Oct 9 2018, 4:49 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptOct 9 2018, 4:49 PM

The team's initial list of target wikis is here: https://www.mediawiki.org/wiki/Mobile_editing_using_the_visual_editor_report#Target_wikis They were selected to be mid-sized Wikipedias with a significant number of editors who are already using mobile (and therefore likely to benefit the most from improvements to mobile editing).

Many of the target wikis have a Tech Ambassador named at https://meta.wikimedia.org/wiki/Tech/Ambassadors/List

Schedule notes:

We expect to request early feedback from any/all communities during the first week of November.

After that, I expect to talk to a couple of Wikipedias about testing any resulting improvements. The most likely candidates (but it all depends upon the results of that early feedback) are an Indic language (e.g., Hindi or Bangla) and a RTL (i.e., Arabic, Persian, or Hebrew). The hope is to identify at least two mid-sized Wikipedias.

Therefore, this task is very likely to be finished by the end of 2019.

At the request of the team, I've also contacted @deryckchan about the possibility of involving the Cantonese Wikipedia.

@Whatamidoing-WMF : Deryck here. Am up for trying it myself and inviting other Cantonese Wikipedia editors to take part. What should I do?

Thanks for the quick reply, Deryck. I think that the first useful thing that you can do is to try the visual editor on a mobile device, using mobile site. (Find a phone or tablet, go to the mobile site, log in, open the wikitext editor, and switch to the visual editor mode in the toolbar, and try to improve the article.) That'll give you a feel for what it can and can't do right now. Anything that's bad/awkward/broken can be reported here. @dchan is the best person to ping if you have problems with normal typing.

@iamjessklein, Deryck is an admin at zh-yuewiki. He is (a) awesome and (b) willing to try out whatever you want. Is there anything in particular that you'd like him to do right now?

deryckchan added a comment.EditedFeb 13 2019, 6:55 PM

A few thoughts so far.

What works:

  • Typing is fine. The mobile VE interface works with my Gboard alright. Chinese characters and IMEs don't seem to cause particular trouble for VE.
  • Linking and formatting by clicking on the icons is fine.
  • Generating references by Citoid is fine.

What doesn't work:

  • Attempting to use voice typing inside VE causes voice typing to give up straight away.
  • Copying and pasting doesn't work. Formatting and links are stripped inconsistently, sometimes converting into plain text, other times dumping raw metadata into the text as plaintext.
ppelberg added a comment.EditedFeb 22 2019, 6:20 PM

Thank you for leading on this, @Whatamidoing-WMF

@deryckchan, hi 👋.

We appreciate – and are excited by – your willingness to experiment with us. Especially considering what these new features are responding to and intending to affect. More on that shortly.

First, to the points you raised about the current mobile VisualEditor experience…

1) VE-Gboard interaction

DC: Typing is fine. The mobile VE interface works with my Gboard alright. Chinese characters and IMEs don't seem to cause particular trouble for VE.

PP: Does the mobile VE and GBoard interaction fall short in anyway or behave in ways that are unexpected? The use of “alright” in this context is leading me to want to clarify.

2) Linking and formatting

DC: Linking and formatting by clicking on the icons is fine.

PP: Were there parts of the linking and formatting workflows that behaved in ways that differed from how you expected them to? The use of “fine” in this context is leading me to wonder whether something went wrong or in a way that was not expected.

3) Citoid

DC: Generating references by Citoid is fine.

PP: Were there parts of the Citoid workflows that behaved in ways that differed from how you expected them to? The use of “fine” in this context is leading me to wonder whether something went wrong or in a way that was not expected.

4) Voice typing inside of VE

DC: Attempting to use voice typing inside VE causes voice typing to give up straight away.

PP: "Give up”…what steps did you take to activate voice typing? At what point did voice typing fail? In what way(s) did voice typing fail? Any details you can share will give us a boost in tracking down potential causes.

5) VE not handling copying and pasting well

DC: Copying and pasting doesn't work. Formatting and links are stripped inconsistently, sometimes converting into plain text, other times dumping raw metadata into the text as plaintext.

PP: A couple questions on this one... a) Do you recall what link(s) VisualEditor did not handle well? If you feel comfortable sharing the actual links, that would be awesome. b) Do you recall where the links were being pasted from (i.e. Gmail)? Issues with copying and pasting contenting into VE have come up in the past, so in asking "a)" and "b)" I am trying to see if they might connect back to something we've seen prior. (i.e. T137831 and T119432)

*By the way, I hope the questions I've asked regarding what is meant by "fine," "alright," "give up" etc. don't come across negatively in any way :) I appreciate how these words can mean different things to different people in different contexts. As such, my questions are an effort to make sure we are building off of a shared understanding...

@ppelberg / @Whatamidoing-WMF : Sorry for the British understatement. By "fine" and "alright" in (1) VE-Gboard interaction, (2) formatting and linking, and (3) Citoid, I meant that all features I tried behaved as expected, and to my satisfaction.

I do have a feature request for (2) formatting and linking though. It seems that the text class (title, subtitle, sub-subtitle etc) and the list / indent menu are missing from the mobile VE interface. Given what buttons are available, I would expect these to be folded into the A (text formatting) menu. Similarly, an insert menu (or another way of folding the desktop VE "insert" and "symbol" menus into the mobile VE interface) would be useful.

(4) Voice typing
Steps to reproduce this failure:

  1. Click on somewhere in a VE screen where you want to type text.
  2. Click on the voice typing button on Gboard.
  3. Start speaking.
  4. After it listens to you speak, it jumps to "Please try again" directly, without attempting to transcribe anything.
  5. (Repeat steps 2-4 and get the same result.)

I can confirm that, on the same device and the same network, I can use Google Voice Typing with the same procedure but on a standard text box rather than the VE edit screen, and it will transcribe my words.

(5) Copying and pasting
Here are some example behaviours:

  • Copying from reading mode in mobile web Wikipedia to mobile VE: everything is pasted as plain text
  • Copying within the same VE screen: text formatting is stripped; references' metadata are dumped as plain text
  • Copying from VE on one article to mobile VE on another article: text formatting is stripped; references' metadata are dumped as plain text
Whatamidoing-WMF closed this task as Resolved.Apr 12 2019, 1:22 AM

Improving mobile editing may need to be done for many years, but the next stage can have separate tasks.

ppelberg added subscribers: DLynch, Esanders.EditedApr 13 2019, 1:21 AM

Goodness @deryckchan – I'm sorry for the multi-month delay! This conversation re-emerging now – by way of @Whatamidoing-WMF's comment – interestingly comes at the perfect time: we are planning our work for the next 3 months, all of which will involve further improvements to the mobile VisualEditor.

Now to your comments...

1) VE-Gboard interaction, 2) Linking and formatting, 3) Citoid

@ppelberg / @Whatamidoing-WMF : Sorry for the British understatement. By "fine" and "alright" in (1) VE-Gboard interaction, (2) formatting and linking, and (3) Citoid, I meant that all features I tried behaved as expected, and to my satisfaction.

Oh ok, great. And thank you for clarifying that :) [1]

Text formatting enhancements

It seems that the text class (title, subtitle, sub-subtitle etc) and the list / indent menu are missing from the mobile VE interface. Given what buttons are available, I would expect these to be folded into the A (text formatting) menu. Similarly, an insert menu (or another way of folding the desktop VE "insert" and "symbol" menus into the mobile VE interface) would be useful.

Mmm, considering the buttons that are available, I can see how the absence of title, subtitle, sub-subtitle, etc. could come as a surprise. Holding expectations aside for a second, how frequently have you found yourself needing these features (additional text styling features and those contained within "insert" and "symbol" menus on desktop) during the course of making an edit on mobile using VE, only to find them not there? What kinds of edits were you needing to make? This question sits inside of a broader exploration into what edit workflows we should prioritize improving in the short-term.

4) Voice typing

(4) Voice typing
Steps to reproduce this failure:

  1. Click on somewhere in a VE screen where you want to type text.
  2. Click on the voice typing button on Gboard.
  3. Start speaking.
  4. After it listens to you speak, it jumps to "Please try again" directly, without attempting to transcribe anything.
  5. (Repeat steps 2-4 and get the same result.)

I can confirm that, on the same device and the same network, I can use Google Voice Typing with the same procedure but on a standard text box rather than the VE edit screen, and it will transcribe my words.

Thank you for laying this out as clearly as you have. I've represented this in a new issue: T220868. Do you recall the device, browser and OS you experienced this issue in? It'd go a long way in trying to reproduce this.

5) VE not handling copying and pasting well

(5) Copying and pasting
Here are some example behaviours:

  • Copying from reading mode in mobile web Wikipedia to mobile VE: everything is pasted as plain text
  • Copying within the same VE screen: text formatting is stripped; references' metadata are dumped as plain text
  • Copying from VE on one article to mobile VE on another article: text formatting is stripped; references' metadata are dumped as plain text

Similar question to above: do you recall the device, browser and OS you experienced this issue in?

...I'm having a bit of trouble reproducing links and references being stripped upon being pasted into VE. This is me trying to copy and paste linked content from reading mode in mobile web to mobile VE in Safari, on a iPhone XS running on iOS 12.1.4: https://youtu.be/rV0WqlU8aBk


  1. British understatements: I'm not sure if/how well you know @Esanders, @DLynch and @dchan, but they're doing their fair share helping me to better understand British tone. @DLynch posted this translation which was pretty funny: chat shows what British people say....
ppelberg claimed this task.Apr 13 2019, 1:21 AM
ppelberg added a subscriber: Whatamidoing-WMF.
ppelberg reopened this task as Open.Apr 13 2019, 1:26 AM
Elitre added a subscriber: Elitre.Apr 13 2019, 11:07 AM

Another task where it doesn't seem straightforward how to evaluate Sherry's contribution. (Besides, it's been reopened and reassigned.) I'll assume no evaluation survey needs to be filed for this. Please LMK if you feel differently.

Another task where it doesn't seem straightforward how to evaluate Sherry's contribution.

Noted, @Elitre. Do you think an improvement for this quarter's tasks, would be for Sherry and I to confirm the acceptance criteria is specific and objective before work beginning?

(Besides, it's been reopened and reassigned.)

@Elitre, ah I'm sorry if this caused any confusion. What do you think would be a better way to handle a situation such as this where I was wanting to continue an open thread, not necessarily related to the completion of the task's description?

What do you think would be a better way to handle a situation such as this where I was wanting to continue an open thread, not necessarily related to the completion of the task's description?

This doesn't happen very often (maybe once a year?), so I'm not sure that we need a formal procedure for it.

What do you think would be a better way to handle a situation such as this where I was wanting to continue an open thread, not necessarily related to the completion of the task's description?

This doesn't happen very often (maybe once a year?), so I'm not sure that we need a formal procedure for it.

Roger that.

Hi all. I think we do need a central discussion thread to make design decisions for Mobile VE, and I don't mind continuing here.

Holding expectations aside for a second, how frequently have you found yourself needing these features (additional text styling features and those contained within "insert" and "symbol" menus on desktop) during the course of making an edit on mobile using VE, only to find them not there? What kinds of edits were you needing to make?

In descending order of usage, I would rank the various text formatting features thus (for article space):

  1. Wikilink
  2. Cite
  3. Make section heading
  4. Insert image
  5. Insert template
  6. Make bulleted / enumerated lists
  7. Change categories
  8. Bold
  9. Insert symbol
  10. Italics / underline
  11. All other formatting options

I guess what prompted my previous comment was that making section headings and inserting images are both quite high-priority in my article-writing workflow (notably, higher than bold / italics), so I was rather surprised that those two features were unavailable.

If we roll this out to discussion space as well, the order will be a bit different:

  1. Signature
  2. Indented list
  3. Bulleted / enumerated lists
  4. Bold / italics / underline
  5. Wikilink
  6. Insert symbol
  7. Insert template
  8. Make section heading
  9. Insert image
  10. All other formatting options

Similar question to above: do you recall the device, browser and OS you experienced this issue in?
...I'm having a bit of trouble reproducing links and references being stripped upon being pasted into VE.

I used Android 8.0.0 with either Chrome or Samsung Browser. Neither browser let me copy and paste formatting correctly from one Mobile VE screen to another.

Another task where it doesn't seem straightforward how to evaluate Sherry's contribution.

Noted, @Elitre. Do you think an improvement for this quarter's tasks, would be for Sherry and I to confirm the acceptance criteria is specific and objective before work beginning?

(Besides, it's been reopened and reassigned.)

@Elitre, ah I'm sorry if this caused any confusion. What do you think would be a better way to handle a situation such as this where I was wanting to continue an open thread, not necessarily related to the completion of the task's description?

Sorry, didn't mean to sound whiny :)
No worries around this specific task. Thanks.

@deryckchan, it's clear we have a lot to learn from you and carrying on a conversation with ~4 weeks in between responses is not satisfactory. I apologize for this cadence.

To this end, I wonder if you'd be open to talking on the phone sometime next week? Hopefully you just received my email (sent via MediaWiki's "Email this user" feature) – I thought we could work out the details there.

Please let me know if my email didn't come through.

@deryckchan and I are going to talk about the items in this thread during our phone call, scheduled for this Wednesday, 29-May.